﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;
using PostSharp.Aspects;

namespace ContactManager.Aspects
{
    [Serializable]
    public sealed class TraceExceptionAttribute : OnExceptionAspect
    {
        public override void OnException(MethodExecutionArgs args)
        {
            Trace.TraceError("Exception {0} in method {1}.{2}",
                args.Exception.GetType().Name,
                args.Method.DeclaringType,
                args.Method.Name);

            if ( args.Instance != null )
            {
                ObjectDumper.DumpObject(args.Instance);
            }

            foreach (object argument in args.Arguments)
            {
                ObjectDumper.DumpObject(argument);
            }
        }
    }
}
